local CombuctorSet = Combuctor:GetModule("Sets")

-- Profession Icon Name
local IconPathName="Interface/Icons/INV_Scroll_10"

local Class_Glyphs=select(5, GetAuctionItemClasses())
local Class_TradeGoods=select(6, GetAuctionItemClasses())
local Class_Consumables=select(4, GetAuctionItemClasses())
local Class_Quest=select(12, GetAuctionItemClasses())

local SubClass_Herbs=select(6, GetAuctionItemSubClasses(6))
local SubClass_OffHand=select(1, GetAuctionItemSubClasses(2))

-- Tab Names
local TN={}
TN.All=ALL
TN.Scribe="Scribe"; 

function TN.isInscriptionGood(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	return TN.isInk(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
		or TN.isHerb(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
		or TN.isPigment(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
		or TN.isScroll(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
		or TN.isCard(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
		or TN.isOther(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	    or TN.isGlyph(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc);
end

function TN.isInk(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	
	return string.find(name, "Ink") ~= nil and type==Class_TradeGoods and string.find(name, "Set") == nil;
end

function TN.isPigment(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	
	return string.find(name, "Pigment") ~= nil and type==Class_TradeGoods;
end

function TN.isParchment(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	
	return string.find(name, "Parchment") ~= nil and type==Class_TradeGoods;
end

function TN.isGlyph(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end

	return string.find(name, "Glyph") ~= nil and type==Class_Glyphs;
end

function TN.isScroll(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end

	return (string.find(name, "Scroll") ~= nil or string.find(name, "Runescroll")) and type==Class_Consumables;
end

function TN.isOther(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	
	return (string.find(name, "Ink") ~= nil and type==Class_TradeGoods and string.find(name, "Set") ~= nil)
		or TN.isParchment(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
		or TN.isBook(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
		or TN.isScroll(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
		or TN.isCard(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
		or string.find(name, "Origami") ~= nil
		or string.find(name, "Documents") ~= nil
		or (name == "Certificate of Ownership")
		or (name == "Vanishing Powder")
		or (name == "Dust of Disappearance")
		or (name == "Etched Horn")
		or (name == "Runed Dragonscale")
		or (name == "Notched Jawbone")
		or (name == "Silver Inlaid Leaf")
		or (name == "Tattooed Eyeball")
		or (name == "Enchanting Vellum");
end

function TN.isInkOrPigment(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc) 
	return TN.isInk(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
		or TN.isPigment(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc);
end
	

function TN.isCard(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	
	if type ~= Class_Quest then return; end
	
	return string.find(name, "Ace of") ~= nil
		or string.find(name, "Two of") ~= nil
		or string.find(name, "Three of") ~= nil
		or string.find(name, "Four of") ~= nil
		or string.find(name, "Five of") ~= nil
		or string.find(name, "Six of") ~= nil
		or string.find(name, "Seven of") ~= nil
		or string.find(name, "Eight of") ~= nil
		or string.find(name, "Card") ~= nil
		or string.find(name, "Deck") ~= nil;
end

function TN.isHerb(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	
	return subType==SubClass_Herbs;
end

function TN.isBook(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end

	if subType ~= SubClass_OffHand then return; end

	return string.find(name, "Book") ~= nil
		or string.find(name, "Tome") ~= nil
		or string.find(name, "Manual") ~= nil
		or string.find(name, "Companion") ~= nil
		or name == "Rituals of the New Moon"
		or name == "Faces of Doom"
		or name == "Adventurer's Journal"
		or string.find(name, "Guide") ~= nil;
end

CombuctorSet:Register(TN.Scribe, IconPathName, TN.isInscriptionGood)

CombuctorSet:RegisterSubSet(TN.All,		TN.Scribe,nil,TN.isInscriptionGood)
CombuctorSet:RegisterSubSet("Herbs",    TN.Scribe,nil,TN.isHerb)
CombuctorSet:RegisterSubSet("Inks", TN.Scribe,nil,TN.isInkOrPigment)
CombuctorSet:RegisterSubSet("Glyphs",	TN.Scribe,nil,TN.isGlyph)
CombuctorSet:RegisterSubSet("Other",	TN.Scribe,nil,TN.isOther)
